const chatContainer = document.getElementById('chatContainer');
const chatInput = document.getElementById('chatInput');
const sendButton = document.getElementById('sendButton');
const modelSelect = document.getElementById('modelSelect');
let conversationOngoing = false;
chatInput.disabled = false;
loadingOverlay.style.display = 'flex';
const confirmationDialog = document.getElementById("confirmationDialog");
const modalMessage = document.getElementById("modalMessage");
const confirmButton = document.getElementById("confirmButton");
const cancelButton = document.getElementById("cancelButton");
let previousModel = document.getElementById("modelSelect").value;
let cuurentModel = document.getElementById("modelSelect").value;
//const loadingOverlay = document.getElementById("loadingOverlay");
const loadingMessage = loadingOverlay.querySelector("p");

const closeButton = document.getElementById('closeButton');
const clearButton = document.getElementById('clearButton');

const imageUpload = document.getElementById('imageUpload');
const imagePreview = document.getElementById('imagePreview');
const textField = document.getElementById('chatInput');
const upload_icon = document.getElementById('upload-icon');
const unetIters = document.getElementById('unetIters');
const iterationsContainer = document.getElementById('iterationsContainer');
const languageSelect = document.getElementById('languageLabel');
let selectSourceLang = document.getElementById('selectSourceLang');
let selectTargetLang = document.getElementById('selectTargetLang');
languageSelect.style.display = 'none';

selectSourceLang.value = "English";
selectTargetLang.value = "Hindi";

hideIterations();
unetIters.value = 5;
upload_icon.style.display = "none";
var img_path;
var isModelImage = false;
var session_id;
var isModelTranslation = false;
// WebSocket setup
// const ws = new WebSocket(`ws://${location.hostname}:${window.wsPort}`); 
const queryParams = new URLSearchParams(window.location.search);
const socketPort = queryParams.get('socket_port') || '8080';
const ws = new WebSocket(`ws://${location.hostname}:${socketPort}`);

// Object to store messages by sessionId
const sessionMessages = {};
// Global variables
let output = "";
let buffer = "";
let isCodeBlock = false;
let isInlineCode = false;
let isHeader = false;
let isOrderedList = false;
let isUnorderedList = false;
let isImageGenerated = false;
let testString = "#Heading1\n##Heading2\n###Heading3\n####Heading4\n#####Heading5\n######Heading6\n" +
    "- bullet point 1 \n- bullet point 2 \n- bullet point 3 \n" + "\nNew para\n" +
    "line with some code `inline code` `inline python code a**b c**d should not be bold` **bold** *emphasized* *italic* ~~strikethrough~~ words end.\n" +
    "* bullet point 1 \n* bullet point 2 \n* bullet point 3 \n" +
    "## Now heading with some code `inline code` **bold** *italic* ~~strikethrough~~ words end.\n" +
    "```python\na=5\nb=5\ndef power(x, y):\n  #to exponentiate 2 numbers\n    res=x**y # stores result\n    return res```\n" +
    "```cpp\nstd::cin>>abc;\nstd::cout<<abc<<endl;\nstd::cin>>abc;\n```" +
    "* **bold keyword**: general words\n* **bold keyword2**: general words\n* **bold keyword3**: general words\n" +
    "**bold** **bold1** not bold **bold2** ** not bold** **not bold ** **** *****\n" +
    "*italic* *italic1* not italic *italic2* * not italic* *not italic * ** ***\n" +
    "~~strikethrough~~ ~~stthr1~~ not stthr ~~stthr2~~ ~~ not strikethrough~~ ~~not strikethrough ~~ ~~~~ ~~~~~\n" +
    "\n\n";


function escapeHTML(str) {
    return str.replace(/[&<>"']/g, (char) => {
        switch (char) {
            case '&': return '&amp;';
            case '<': return '&lt;';
            case '>': return '&gt;';
            case '"': return '&quot;';
            case "'": return '&apos;';
            default: return char;
        }
    });
}

function flushBufferToOutput() {
    if (buffer) {
        output += buffer;
        buffer = "";
    }
}


// Add these lines to your existing scripts.js file

// Custom Model Dialog Handling
const customModelDialog = document.getElementById('customModelDialog');
const customModelForm = document.getElementById('customModelForm');
const cancelCustomModelButton = document.getElementById('cancelCustomModelButton');





cancelCustomModelButton.addEventListener('click', () => {
    // Reset model select to previous value
    ws.send(JSON.stringify({ type: "model_init" }));

    modelSelect.value = previousModel;
    customModelDialog.style.display = 'none';
});


clearButton.addEventListener('click', () => {
    ws.send(JSON.stringify({ type: "clear" }));

    // Clear the chat container
    chatContainer.innerHTML = '';
    updateConnectionStatus('Context limit hit please clear chat', 'active', false);
    conversationOngoing = false; // Conversation ongoing
    // Reset any session data if needed
    // Object.keys(sessionMessages).forEach(key => {
    //     delete sessionMessages[key];
    // });
    sendButton.disabled = false;
    clearButton.style.background = "linear-gradient(to right, #3b3b3b, #4a4a4a)";


    // Reset conversation state
    conversationOngoing = false;
    chatInput.disabled = false;
    sendButton.textContent = "Send";
    modelSelect.disabled = false;
    if (upload_icon) {
        upload_icon.style.pointerEvents = 'auto';
    }

    // Reset any global states
    output = "";
    buffer = "";
    isCodeBlock = false;
    isInlineCode = false;
    isHeader = false;
    isOrderedList = false;
    isUnorderedList = false;
});

// Close the custom model dialog if clicked outside
window.addEventListener('click', (event) => {
    if (event.target === customModelDialog) {
        modelSelect.value = previousModel;
        customModelDialog.style.display = 'none';
    }
});

function useOpacityMethod() {
    unetIters.classList.remove('hidden-position', 'hidden-scale');
    unetIters.classList.add('hidden-opacity');
}
function resetDisplay() {
    unetIters.classList.remove('hidden-opacity', 'hidden-position', 'hidden-scale');
}

// Function to hide iterations using Method 1 (opacity/visibility)
function hideIterations() {
    iterationsContainer.classList.add('hidden-opacity');
}

// Function to show iterations
function showIterations() {
    iterationsContainer.classList.remove('hidden-opacity');
}

function processInlineModifiers(chunk) {
    let processed = chunk;

    const codePattern = /<code style="display: inline;">.*?<\/code>/g;
    const codeSegments = [];

    processed = processed.replace(codePattern, (match) => {
        codeSegments.push(match);
        return `@@CODE_${codeSegments.length - 1}@@`;
    });

    const boldPattern = /\*\*(?=\S)([^*\s](.*?\S)?[^*\s])\*\*/g;
    const emphasizedPattern = /\*(?=\S)([^*\s](.*?\S)?[^*\s])\*/g;
    const strikethroughPattern = /~~(?=\S)([^~\s](.*?\S)?[^~\s])~~/g;

    processed = processed
        .replace(boldPattern, "<strong>$1</strong>")
        .replace(emphasizedPattern, "<em>$1</em>")
        .replace(strikethroughPattern, "<del>$1</del>");

    processed = processed.replace(/@@CODE_(\d+)@@/g, (_, index) => codeSegments[+index]);

    return processed;
}

function mdToHTML(chunk) {

    chunk = escapeHTML(chunk);

    for (const char of chunk) {
        buffer += char;

        if (isCodeBlock) {

            if (buffer.endsWith("```")) {
                isCodeBlock = false;
                output += buffer.slice(0, -3) + "</code></pre>";
                buffer = "";
            }
            continue;
        }

        if (buffer.endsWith("```")) {
            buffer = processInlineModifiers(buffer.slice(0, -3));
            if (isHeader) {
                isHeader = false;
                buffer += "<h" + buffer.slice(2, 4);
            }
            if (isUnorderedList) {
                isUnorderedList = false;
                buffer += "</ul>\n";
            }
            flushBufferToOutput();
            isCodeBlock = true;
            buffer = "<pre><code>";
            continue;
        }

        if (isInlineCode) {
            if (buffer.endsWith("`")) {
                isInlineCode = false;
                buffer = buffer.slice(0, -1) + "</code>";
            }
            continue;
        }

        if (buffer.length > 1 && buffer[buffer.length - 1] !== '`' && buffer[buffer.length - 2] === '`') {
            isInlineCode = true;
            buffer = processInlineModifiers(buffer.slice(0, -2)) + "<code style=\"display: inline;\">" + buffer.charAt(buffer.length - 1);
        }

        if (isHeader) {
            if (buffer[buffer.length - 1] === '#') {
                let lastTag = buffer.slice(-5, -1);
                if (lastTag.match(/<h[1-9]>$/)) {
                    let currentLevel = parseInt(lastTag[2]);
                    let nextLevel = currentLevel + 1;

                    buffer = buffer.slice(0, buffer.length - 5) + `<h${nextLevel}>`;
                }
            }
            if (buffer[buffer.length - 1] === '\n') {
                isHeader = false;
                output += buffer.slice(0, 4) + processInlineModifiers(buffer.slice(4, -1)) + "</h" + buffer.slice(2, 4) + "\n";
                buffer = "";
            }
            continue;
        }

        if (buffer[buffer.length - 1] === '#') {
            buffer = processInlineModifiers(buffer.slice(0, -1));
            if (isUnorderedList) {
                isUnorderedList = false;
                buffer += "</ul>\n";
            }
            flushBufferToOutput();

            buffer = "<h1>";
            isHeader = true;
            continue;
        }

        if (isUnorderedList) {
            if (buffer.length > 4 && buffer[buffer.length - 1] === '\n') {
                output += processInlineModifiers(buffer.slice(0, -1)) + "</li>\n";
                buffer = "";
                continue;
            }
            if ((buffer.trim() === "-" && buffer.slice(-2) === "- ") || (buffer.trim() === "*" && buffer.slice(-2) === "* ")) {
                buffer = "<li>";
                continue;
            } else if (buffer.trim().length > 1 && buffer.trim().length < 4) {
                output += "</ul>\n";
                isUnorderedList = false;
            } else if (buffer[buffer.length - 1] === "\n") {
                output += "</ul>\n<br>";
                isUnorderedList = false;
                buffer = "";
                continue;
            }
        }

        if (buffer.trim().length === 1 && (buffer.slice(-2) === "* " || buffer.slice(-2) === "- ")) {
            isUnorderedList = true;
            buffer = "<ul>\n<li>";
            continue;
        }

        if (buffer[buffer.length - 1] === '\n') {
            output += processInlineModifiers(buffer) + "<br>";
            buffer = "";
        }

    }

    if (isCodeBlock) {
        return output + buffer + "</code></pre>";
    }

    if (isInlineCode) {
        return output + buffer + "</code>";
    }

    if (isHeader) {
        return output + buffer + "</h" + buffer.slice(2, 4);
    }

    if (isOrderedList) {
        return output + processInlineModifiers(buffer) + "</li>\n</ol>\n";
    }

    if (isUnorderedList) {
        return output + processInlineModifiers(buffer) + "</li>\n</ul>\n";
    }

    return output + processInlineModifiers(buffer);
}


imageUpload.addEventListener('change', function (event) {
    const file = event.target.files[0];
    if (file) {
        const reader = new FileReader();
        reader.onloadend = function (e) {
            const fileURL = URL.createObjectURL(file);

            const base64String = reader.result.split(',')[1];
            img_path = base64String;
            isModelImage = true;
            imagePreview.src = e.target.result; // Set the preview image source
            imagePreview.style.display = 'block'; // Show the preview
            closeButton.style.display = 'block';
            imageUpload.value = '';


        };
        reader.readAsDataURL(file);
    }
});


closeButton.addEventListener('click', () => {
    imagePreview.src = '';
    imagePreview.style.display = 'none';
    closeButton.style.display = 'none';
    isModelImage = false;
    imageUpload.value = ''; // Clear the file input
});


ws.onopen = () => {
    // console.log('WebSocket connected');
    updateConnectionStatus('Connected', 'active', false);
    ws.send(JSON.stringify({ type: "model_init" }));
    reconnectAttempts = 0; // Reset attempts
};

ws.onclose = () => {
    // console.log('WebSocket disconnected');
    updateConnectionStatus('Disconnected from the server', 'active', true);
    attemptReconnection();
    chatInput.disabled = true;
};

ws.onerror = (error) => {
    console.error('WebSocket error:', error);
    updateConnectionStatus('Disconnected due to an error', 'active', true);
    chatInput.disabled = true;
};

// WebSocket `onmessage` event handler
ws.onmessage = (event) => {
    if (event.data instanceof Blob) {
        const reader = new FileReader();
        reader.onload = function (e) {
            //console.log(e.target.result);
            handleIncomingMessage(JSON.parse(e.target.result));
        };
        reader.readAsText(event.data);
    } else {
        // console.log(event.data);
        handleIncomingMessage(JSON.parse(event.data));
    }
};

// Function to handle incoming WebSocket messages
function handleIncomingMessage(messageObject) {
    const { message, sessionId, type, size, model_name, time, download_status } = messageObject;

    // Check if sessionId exists, otherwise initialize it
    // console.log(type);
    if (type === 'model_loaded') {
        // Hide loading animation
        loadingOverlay.style.display = 'none';
        chatInput.disabled = false;
        const option = document.createElement("option");

        console.log(`Model loaded: ${model_name}`);
        let exists = Array.from(modelSelect.options).some(opt => opt.value === model_name);

        if (!exists) {
            option.value = model_name;
            option.text = model_name;
            modelSelect.add(option);
        }


        document.getElementById("modelSelect").value = model_name || cuurentModel;
        // option.style.display = "none";


        if (model_name == "Qwen2-VL-2B") {
            upload_icon.style.display = "block";

        } else {
            upload_icon.style.display = "none";

        }
        if (model_name == "IndicTrans2-en-indic-distilled") {

            let valueToAdd = 'English'; // example value
            let textToAdd = 'English'; // example display text
            let exists = Array.from(selectSourceLang.options).some(option => option.value === valueToAdd);
            if (!exists) {
                let newOption = new Option(textToAdd, valueToAdd);
                selectSourceLang.add(newOption); // or use appendChild if you prefer
            }
            selectSourceLang.value = "English";
            for (let i = 0; i < selectTargetLang.options.length; i++) {
                if (selectTargetLang.options[i].value === "English") {
                    selectTargetLang.remove(i);
                    break;
                }
            }
            selectTargetLang.disabled = false;
            selectSourceLang.disabled = true;
        }

        if (model_name == "IndicTrans2-indic-en-distilled") {
            let valueToAdd = 'English'; // example value
            let textToAdd = 'English'; // example display text
            let exists = Array.from(selectTargetLang.options).some(option => option.value === valueToAdd);
            if (!exists) {
                let newOption = new Option(textToAdd, valueToAdd);
                selectTargetLang.add(newOption); // or use appendChild if you prefer
            }

            selectTargetLang.value = "English";
            for (let i = 0; i < selectSourceLang.options.length; i++) {
                if (selectSourceLang.options[i].value === "English") {
                    selectSourceLang.remove(i);
                    break;
                }
            }
            selectSourceLang.disabled = false;

            selectTargetLang.disabled = true;

        }

        if (model_name == "IndicTrans2-indic-indic-distilled") {
            for (let i = 0; i < selectSourceLang.options.length; i++) {
                if (selectSourceLang.options[i].value === "English") {
                    selectSourceLang.remove(i);
                    break;
                }
            }
            for (let i = 0; i < selectTargetLang.options.length; i++) {
                if (selectTargetLang.options[i].value === "English") {
                    selectTargetLang.remove(i);
                    break;
                }
            }
            selectSourceLang.disabled = false;

            selectTargetLang.disabled = false;
        }


        if (model_name == "IndicTrans2-en-indic-distilled" || model_name == "IndicTrans2-indic-en-distilled" || model_name == "IndicTrans2-indic-indic-distilled") {
            languageSelect.style.display = '';
            isModelTranslation = true;
        } else {
            languageSelect.style.display = 'none';
            isModelTranslation = false;
        }

        if (model_name == "Stable_Diffusion1.5") {
            isImageGenerated = true;
            showIterations();
        } else {
            isImageGenerated = false;
            hideIterations();
        }


        // Clear the chat container
        chatContainer.innerHTML = '';

        // Reset any session data if needed
        // Object.keys(sessionMessages).forEach(key => {
        //     delete sessionMessages[key];
        // });

        // Reset conversation state
        conversationOngoing = false;
        chatInput.disabled = false;
        sendButton.textContent = "Send";
        modelSelect.disabled = false;
        if (upload_icon) {
            upload_icon.style.pointerEvents = 'auto';
        }

        // Reset any global states
        output = "";
        buffer = "";
        isCodeBlock = false;
        isInlineCode = false;
        isHeader = false;
        isOrderedList = false;
        isUnorderedList = false;

        // For testing purpose only
        // createOrUpdateMessageElement(sessionId);
        // updateMessageElement(sessionId, testString);  0
    } else if (type === 'model_not_found') {
        loadingOverlay.style.display = 'none';
        const modelSize = size || "unknown size";
        modalMessage.textContent = `The selected model (${cuurentModel}) does not exist. You need to download it first. Model size: ${modelSize}. Do you want to proceed?`;
        confirmationDialog.style.display = "block";

        // Restore the previous selection temporarily
        event.target.value = previousModel;
    } else if (type === 'model_downloading') {
        loadingMessage.textContent = "Model is downloading...";
        loadingOverlay.style.display = "flex";
    } else if (type === 'estimated_time') {
        loadingMessage.textContent = `The LLM model is gearing up—give it around ${time} to load!`;
        loadingOverlay.style.display = "flex";
    } else if (type === 'model_download_failed') {
        updateConnectionStatus('Model downloading is faild please select model again', 'active', true);
        loadingMessage.textContent = "Model is downloaded please wait for loading...";
        loadingOverlay.style.display = 'none';
        document.getElementById("modelSelect").value = "Select Model";
        chatInput.disabled = true;

    }
    else if (type === 'download_percent') {
        //	console.log(download_status);    
        loadingMessage.textContent = `${download_status}`;
        loadingOverlay.style.display = "flex";
    } else if (type === 'model_downloaded') {
        loadingOverlay.style.display = "flex";
        loadingMessage.textContent = `Model Downloaded`;
    } else if (type === 'context_full_clear_chat') {
        updateConnectionStatus('Context limit hit please clear chat', 'active', true);
        modelSelect.disabled = true;
        conversationOngoing = true; // Conversation ong
        sendButton.textContent = "Send";
        sendButton.disabled = true;
        clearButton.disabled = false;
        clearButton.style.background = "red"; // Red color



    } else if (type === 'endOfConv') {
        conversationOngoing = false; // End the conversation
        chatInput.disabled = false; // Disable input
        upload_icon.style.pointerEvents = 'auto'; // Disable click
        modelSelect.disabled = false;
        clearButton.disabled = false;

        sendButton.textContent = "Send";
        removeTypingAnimation(session_id);
        output = "";
        buffer = "";
        isCodeBlock = false;
        isInlineCode = false;
        isHeader = false;
        isOrderedList = false;
        isUnorderedList = false;
    } else if (type === 'image_path') {
        // Create or update the message element for this session
        removeLoadingAnimation(sessionId); // Remove loading animation

        createOrUpdateMessageElement(sessionId);

        // Create an image element
        const imageElement = document.createElement('img');
        imageElement.src = `http://${location.hostname}:${messageObject.serverPort}/${messageObject.path}`; // Use the path from the message
        imageElement.alt = 'Response image';
        imageElement.className = 'response-image';
        imageElement.style.maxWidth = '100%'; // Make sure image fits within the chat container

        // Find the message element and append the image
        const messageElement = document.querySelector(`.chat-message[data-session-id="${sessionId}"]`);
        if (messageElement) {
            messageElement.appendChild(imageElement);
            chatContainer.scrollTop = chatContainer.scrollHeight; // Auto-scroll to bottom
        }

        conversationOngoing = false; // End the conversation
        chatInput.disabled = false; // Disable input
        upload_icon.style.pointerEvents = 'auto'; // Disable click
        modelSelect.disabled = false;
        clearButton.disabled = false;

        sendButton.textContent = "Send";
        // removeTypingAnimation(session_id);
        output = "";
        buffer = "";
        isCodeBlock = false;
        isInlineCode = false;
        isHeader = false;
        isOrderedList = false;
        isUnorderedList = false;
    } else {
        loadingOverlay.style.display = 'none';
        modelSelect.disabled = true;

        removeTypingAnimation(sessionId); // Remove typing animation
        if (!sessionMessages[sessionId]) {
            sessionMessages[sessionId] = ""; // Start with an empty message
            createOrUpdateMessageElement(sessionId); // Create a placeholder in the chat
            output = "";
        }

        conversationOngoing = true; // Conversation ongoing
        chatInput.disabled = true; // Enable input
        sessionMessages[sessionId] += `${message}`;

        // Update the displayed message for the sessionId
        // updateMessageElement(sessionId, sessionMessages[sessionId].trim());
        updateMessageElement(sessionId, message);
    }
}

function updateConnectionStatus(message, className, isError) {
    connectionStatus.textContent = message;
    connectionStatus.className = `connection-status ${className}`;
    if (isError) {
        connectionStatus.style.display = 'block';
    } else {
        connectionStatus.style.display = 'none';
    }
}

// Function to create or find a message element for a sessionId
function createOrUpdateMessageElement(sessionId) {
    let existingMessage = document.querySelector(`.chat-message[data-session-id="${sessionId}"]`);

    if (!existingMessage) {
        const messageElement = document.createElement('div');
        messageElement.className = `chat-message bot-message`;
        messageElement.setAttribute('data-session-id', sessionId);
        chatContainer.appendChild(messageElement);
        chatContainer.scrollTop = chatContainer.scrollHeight;
    }
}

// Function to update the message content for a sessionId
function updateMessageElement(sessionId, content) {
    const messageElement = document.querySelector(`.chat-message[data-session-id="${sessionId}"]`);

    if (messageElement) {
        // Replace *bold* sections and \n with <b> and <br> respectively

        // var formattedContent = content.replace(/\n/g, '<br><br>'); // Line break formatting
        // var formattedContent =convertMarkdown(content); // Bold formatting
        var formattedContent = mdToHTML(content);
        // console.log(formattedContent);  // for testing purpose only
        messageElement.innerHTML = formattedContent; // Use innerHTML to apply formatting
        chatContainer.scrollTop = chatContainer.scrollHeight; // Auto-scroll to bottom
    }
}

modelSelect.addEventListener('change', () => {
    const selectedModel = modelSelect.value; // Get the selected model value
    loadingOverlay.style.display = 'flex';
    cuurentModel = selectedModel;

    if (selectedModel === 'custom') {
        // Show custom model dialog
        customModelDialog.style.display = 'block';
    } else {
        // Check if the selected model is a previously added custom model
        const customOption = Array.from(modelSelect.options).find(
            option => option.value === selectedModel && option.getAttribute('data-custom')
        );

        // Proceed with model switching
        loadingOverlay.style.display = 'flex';
        cuurentModel = selectedModel;
        document.getElementById("modelSelect").value = selectedModel;


        ws.send(JSON.stringify({
            type: "model_switch",
            model_name: customOption
                ? customOption.getAttribute('data-model-path')
                : selectedModel,
        }));
    }
});

// Modify the custom model form submission to add a data attribute
customModelForm.addEventListener('submit', (e) => {
    e.preventDefault();

    // Get values from form
    const modelName = document.getElementById('customModelName').value.trim();
    const modelPath = document.getElementById('customModelPath').value.trim();
    const promptPrefix = document.getElementById('customPromptPrefix').value.trim().replace(/\\n/g, '\n')  // Convert literal '\n' to actual newline
        .replace(/\\r/g, '\r')  // Convert literal '\r' to actual carriage return
        .replace(/\\t/g, '\t'); // Convert literal '\t' to actual tab if needed
    const promptPostfix = document.getElementById('customPromptPostfix').value.trim().replace(/\\n/g, '\n')  // Convert literal '\n' to actual newline
        .replace(/\\r/g, '\r')  // Convert literal '\r' to actual carriage return
        .replace(/\\t/g, '\t'); // Convert literal '\t' to actual tab if needed

    // Validate required fields
    if (!modelName || !modelPath) {
        alert('Model Name and Model Path are required!');
        return;
    }

    // Update model select to show custom model name
    const customOption = document.createElement('option');
    customOption.value = modelName;
    customOption.text = modelName;
    customOption.setAttribute('data-custom', 'true');
    customOption.setAttribute('data-model-path', modelPath);
    modelSelect.add(customOption);
    modelSelect.value = modelName;

    // Send WebSocket message with custom model details
    loadingOverlay.style.display = 'flex';
    cuurentModel = modelName;
    document.getElementById("modelSelect").value = modelName;


    ws.send(JSON.stringify({
        type: "model_switch",
        model_name: modelName,
        model_path: modelPath,
        prompt_prefix: promptPrefix || "",
        prompt_postfix: promptPostfix || ""
    }));

    // Close the dialog
    customModelDialog.style.display = 'none';
});
confirmButton.addEventListener("click", function () {
    const selectedModel = cuurentModel;
    loadingOverlay.style.display = 'flex';

    console.log(`Confirmed selection: ${selectedModel}`);
    document.getElementById("modelSelect").value = cuurentModel;
    confirmationDialog.style.display = "none";
    if (document.getElementById("modelSelect").value == "Qwen2-VL-2B") {
        upload_icon.style.display = "block";

    }
    // Start download logic here
    ws.send(JSON.stringify({
        type: "model_download",
        model_name: cuurentModel,
    }));
});

cancelButton.addEventListener("click", function () {
    console.log("User canceled the model change.");
    document.getElementById("modelSelect").value = previousModel;
    confirmationDialog.style.display = "none";
});

// Close the modal if the user clicks outside of it
window.addEventListener("click", function (event) {
    if (event.target === confirmationDialog) {
        confirmationDialog.style.display = "none";
    }
});
function toggleButtonContent() {
    if (sendButton.textContent === "Send") {

        const inputValue = textField.value.trim(); // Trim to remove leading/trailing spaces

        if (inputValue === '') {

        } else {
            sendMessage();
            sendButton.textContent = "Stop";

        }
    } else {
        // sendButton.textContent = "Send";
        ws.send(JSON.stringify({ type: "stop" }));
    }
}

// Function to send messages
function sendMessage() {
    const message = chatInput.value.trim();
    const selectedModel = modelSelect.value;
    const sessionId = generateSessionId(); // Generate a random session ID
    imagePreview.style.display = 'none'

    closeButton.style.display = 'none';
    upload_icon.style.pointerEvents = 'none'; // Disable click
    session_id = sessionId;

    chatInput.disabled = true;
    clearButton.disabled = true;
    if (message) {

        if (isModelImage) {
            addMessage(message, 'user-message', img_path);
            ws.send(JSON.stringify({ type: "image_message", message, img_path: `${img_path}`, sessionId })); // Send to WebSocket
            isModelImage = false;
        } else if (isImageGenerated) {
            addMessage(message, 'user-message'); // Add user message
            ws.send(JSON.stringify({ type: "message", prompt: message, unetIters: `${unetIters.value}`, sessionId })); // Send to WebSocket
        } else if (isModelTranslation) {
            addMessage(message, 'user-message'); // Add user message
            ws.send(JSON.stringify({ type: "message", "paragraph": message, source_lang: `${selectSourceLang.value}`, target_lang: `${selectTargetLang.value}`, sessionId })); // Send to WebSocket

        } else {
            addMessage(message, 'user-message'); // Add user message
            ws.send(JSON.stringify({ type: "message", message, sessionId })); // Send to WebSocket
        }
        // ws.send(JSON.stringify({ type: "image_message", message,img_path: `${img_path}`,sessionId })); // Send to WebSocket

        chatInput.value = ''; // Clear input
    }
}
function showTypingAnimation(sessionId) {
    // Create or update a typing animation placeholder
    const typingElement = document.createElement('div');
    typingElement.className = 'chat-message bot-message typing';
    typingElement.setAttribute('data-session-id', sessionId);
    typingElement.innerHTML = '<span class="dots"><span></span><span></span><span></span></span>';
    chatContainer.appendChild(typingElement);
    chatContainer.scrollTop = chatContainer.scrollHeight;
}

function removeTypingAnimation(sessionId) {
    // Remove the typing animation once the response is received
    const typingElement = document.querySelector(`.chat-message.typing[data-session-id="${sessionId}"]`);
    if (typingElement) {
        typingElement.remove();
    }
}

function showLoadingAnimation(sessionId) {
    // Create or update a loading animation placeholder
    const loadingElement = document.createElement('div');
    loadingElement.className = 'chat-message bot-message loading';
    loadingElement.setAttribute('data-session-id', sessionId);

    // Create the CSS-only loading spinner with icon
    const spinnerContainer = document.createElement('div');
    spinnerContainer.className = 'spinner-container';

    // Create the spinner with icon
    const spinner = document.createElement('div');
    spinner.className = 'spinner-circle';

    // Create the icon inside
    const iconElement = document.createElement('div');
    iconElement.className = 'spinner-icon';

    // Add icon and spinner to container
    spinner.appendChild(iconElement);
    spinnerContainer.appendChild(spinner);
    loadingElement.appendChild(spinnerContainer);

    chatContainer.appendChild(loadingElement);
    chatContainer.scrollTop = chatContainer.scrollHeight;
}

function removeLoadingAnimation(sessionId) {
    const loadingElement = document.querySelector(`.chat-message.loading[data-session-id="${sessionId}"]`);
    if (loadingElement) {
        loadingElement.remove();
    }
}

// Add event listener for Enter key
chatInput.addEventListener('keydown', (event) => {
    if (event.key === 'Enter') {
        event.preventDefault(); // Prevent new line
        toggleButtonContent();
        // const inputValue = textField.value.trim(); // Trim to remove leading/trailing spaces

        // if (inputValue === '') {

        // } else {
        //     sendMessage();

        // }
    }
});

// Add event listener for Send button

sendButton.addEventListener('click', () => {

    toggleButtonContent();
    // const inputValue = textField.value.trim(); // Trim to remove leading/trailing spaces

    // if (inputValue === '') {

    // } else {
    //     sendMessage();

    // }
});

// Helper to add user messages to the chat
function addMessage(message, type, base64Image = null) {
    const messageElement = document.createElement('div');
    messageElement.className = `chat-message ${type}`;

    // Add the image if a Base64 string is provided
    if (base64Image) {
        const imageElement = document.createElement('img');
        imageElement.src = `data:image/png;base64,${base64Image}`;
        imageElement.alt = "User-uploaded image";
        imageElement.style.maxWidth = '200px'; // Optional: Limit image size
        imageElement.style.display = 'block'; // Ensure it's a block element to appear above text
        messageElement.appendChild(imageElement);
    }

    // Add the text message
    const textElement = document.createElement('p');
    textElement.textContent = message;
    messageElement.appendChild(textElement);

    // Append the message element to the chat container
    chatContainer.appendChild(messageElement);
    chatContainer.scrollTop = chatContainer.scrollHeight;
    if (isImageGenerated) {
        showLoadingAnimation(session_id);
    } else {
        showTypingAnimation(session_id);
    }
}
function parseMarkdown(markdown) {
    // Headings
    markdown = markdown.replace(/^###### (.*$)/gim, '<h6>$1</h6>');
    markdown = markdown.replace(/^##### (.*$)/gim, '<h5>$1</h5>');
    markdown = markdown.replace(/^#### (.*$)/gim, '<h4>$1</h4>');
    markdown = markdown.replace(/^### (.*$)/gim, '<h3>$1</h3>');
    markdown = markdown.replace(/^## (.*$)/gim, '<h2>$1</h2>');
    markdown = markdown.replace(/^# (.*$)/gim, '<h1>$1</h1>');

    // Bold
    markdown = markdown.replace(/\*\*(.*?)\*\*/gim, '<strong>$1</strong>');

    // Italic
    markdown = markdown.replace(/\*(.*?)\*/gim, '<em>$1</em>');

    // Strikethrough
    markdown = markdown.replace(/~~(.*?)~~/gim, '<del>$1</del>');

    // Inline code
    markdown = markdown.replace(/`([^`]+)`/gim, '<code>$1</code>');

    // Code blocks
    markdown = markdown.replace(/```(.*?)\n([\s\S]*?)```/gim, '<pre><code class="$1">$2</code></pre>');

    // Unordered lists
    markdown = markdown.replace(/^- (.*$)/gim, '<li>$1</li>');
    markdown = markdown.replace(/(<li>.*<\/li>)/gim, '<ul>$1</ul>'); // Wrap list items in <ul>

    // Ordered lists
    markdown = markdown.replace(/^\d+\. (.*$)/gim, '<li>$1</li>');
    markdown = markdown.replace(/(<li>.*<\/li>)/gim, '<ol>$1</ol>'); // Wrap list items in <ol>

    // Blockquotes
    markdown = markdown.replace(/^> (.*$)/gim, '<blockquote>$1</blockquote>');

    // Links
    markdown = markdown.replace(/\[(.*?)\]\((.*?)\)/gim, '<a href="$2">$1</a>');

    // Images
    markdown = markdown.replace(/!\[(.*?)\]\((.*?)\)/gim, '<img src="$2" alt="$1" />');

    // Line breaks
    markdown = markdown.replace(/\n/gim, '<br>');

    return markdown.trim();
}


// Generate a random session ID
function generateSessionId() {
    return Math.random().toString(36).substr(2, 9); // Generates a random string of 9 characters
}